"""Unit conversion tool, part of gptools
"""

import math

import gptools.utils.exceptions as exceptions

def metersToFeet(meters):
    """Convert meters to feet.
    """
    if not (type(meters).__name__ == 'float'  or type(meters).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return meters * 3.2808399

def metersToUSFeet(meters):
    """Convert meters to US feet.
    """
    if not (type(meters).__name__ == 'float'  or type(meters).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return meters * 3.280833327749246
    
def metersToMiles(meters):
    """Convert meters to miles.
    """
    if not (type(meters).__name__ == 'float'  or type(meters).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return meters * 0.000621371192

def feetToMeters(feet):
    """Convert feet to meters.
    """
    if not (type(feet).__name__ == 'float'  or type(feet).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return feet * 0.3048

def usFeetToMeters(feet):
    """Convert US feet to meters.
    """
    if not (type(feet).__name__ == 'float'  or type(feet).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return feet * 0.30480061012
    
def feetToMiles(feet):
    """Convert feet to miles.
    """
    if not (type(feet).__name__ == 'float'  or type(feet).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return feet * 0.000189393939

def meters2ToFeet2(meters2):
    """Convert square meters to square feet.
    """
    if not (type(meters2).__name__ == 'float'  or type(meters2).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return meters2 * 10.7639104
    
def feet2ToMeters2(feet2):
    """Convert square meters to square feet.
    """
    if not (type(feet2).__name__ == 'float'  or type(feet2).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return feet2 * 0.09290304

def meters2ToMiles2(meters2):
    """Convert square meters to square miles.
    """
    if not (type(meters2).__name__ == 'float'  or type(meters2).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return meters2 * 0.000000386102159

def miles2ToMeters2(miles2):
    """Convert square meters to square miles.
    """
    if not (type(miles2).__name__ == 'float'  or type(miles2).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return miles2 * 2589998.110336
    
def degreesToRadians(degrees):
    """Convert degrees to radians.
    """
    if not (type(degrees).__name__ == 'float' or type(degrees).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return math.radians(degrees)
    
def radiansToDegrees(radians):
    """Convert radians to degrees.
    """
    if not (type(radians).__name__ == 'float' or type(radians).__name__ == 'int'):
        raise exceptions.NotNumericValue("Parameter given was not a numeric value")
    else:
        return math.degrees(radians)